#!/usr/bin/env ruby
#
#  mk_tkextlib.rb
#
$Mk_TkExtLib_Version = '0.5.1'
#                     2001/07/03  Hidetosh NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'getopts'
require 'tcltkextlib'

#############################
# class & methods definition
#############################
# ޥɸѥ饹
#############################
class TclTkExt_CmdChk
  ##########################################################
  # ¿Υ᥽åɤ private
  private

  # ޥɤΰʸɽβ
  def parse_cmd_info_string (cmd, info)
    q_in_out = info.split('?')
    q_in_out[0].sub!(/\s*#{cmd}\s+/,'') # ޥ̾ޤޤƤк
    args = []
    q_in_out.each_with_index{|item,index|
      next if item.strip! == '' # Τߤʤ鼡
      if index%2 == 0
	# άǽ
	item.split(/\s+/).each{|term| args.push(term)}
      else
	# άǽ (άͤǤ뤿 nil Ȥ)
	# ? Ƕޤ줿ϰϤϰĤȤȤư
	args.push(item.split(/\s+/).collect{|term| [term, nil]})
      end
    }
    print "#######args = ", args.inspect , "\n" if @verbose == 'DEBUG'
    args
  end

  # ƥޥɤθ
  def cmd_args_test (cmd)
    # Tcl command procedure 
    if @ip.eval("info procs #{cmd}") != ''
      if @verbose == 'DEBUG'
	print cmd," is proc, and param is '",@ip.eval("info args #{cmd}"),"'\n"
      end
      arg_names = @ip.eval("info args #{cmd}") # γ
      args = @ip.eval("info args #{cmd}").split(/\s/).collect{|arg|
	if @ip.eval("info default #{cmd} #{arg} arg_default_value") == '0'
	  # ǥեͤʤ
	  arg
	else
	  # ǥեͤ  ¿ʬάǽ
	  #[arg, @ip.eval("set arg_default_value")]
	  [ [arg, @ip.eval("set arg_default_value")] ]
	end
      }
      return cmd, 'procedure', args
    else
      print "#######", cmd, " is not proc\n" if @verbose == 'DEBUG'
      if @ip.eval("catch {#{cmd}} err_msg") == "1"
	# 顼ȯ
	err_msg = @ip.eval("set err_msg")
	# 顼åθ
	if /^wrong # .*?arg.*?should be "(.*?)"/i === err_msg
	  print "####### arg-info is '", $1, "'\n" if @verbose == 'DEBUG'
	  return cmd, 'not-proc', parse_cmd_info_string(cmd, $1)
	elsif (err_msg_lines = err_msg.split("\n")).size > 1
	  if /^wrong # .*?arg.*?should be one of.*$/i === err_msg_lines.shift
	    # ƾ 1 ǤƱ
	    heads = (err_msg_lines.collect{|line|
		       line.strip.split(/\s/)[0]
		     } | [])
	    if heads.size == 1
	      # ƾ 1 ǤƱ   2 Ǥץȿ
	      opts = err_msg_lines.collect{|line|
		['string', line.strip.split(/\s/)[1]]
	      }
	    else
	      # ƾ 1 Ǥۤʤ   1 Ǥץȿ
	      opts = err_msg_lines.collect{|line|
		['string', line.strip.split(/\s/)[0]]
	      }
	    end
	  end

	  # 礷ưᡤץʳΰϤޤȤƤޤ
	  # ˥ץޤƱͿ
	  return cmd, 'not-proc', ['option', 'args'], \
	         'general-cmd', [1, 'option', opts]
	end

	print "####### fail to parse '", err_msg, "'\n"
      else
	# 顼ʤ
	print "####### cmd '", cmd, "' no error ?????\n" if @verbose == 'DEBUG'
	ret_val = []
	test_arg = []
	# ο 10 ޤ䤷ʤƥ
	(0..9).each {|i|
	  # ƱˤĤơ٤ĥƥ
	  ['.tmp_widget', '.tmp_widget', '1', '1'].each{|value|
	    test_arg[i] = value
	    if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") == "1"
	      # 顼ȯ
	      err_msg = @ip.eval("set err_msg")
	      print "####### cmd '", cmd, ' ',test_arg.join(' '),\
	      "' error ", err_msg,"\n" if @verbose == 'DEBUG'
	      return cmd, 'not-proc', nil
	    else
	      # 顼ʤ  ͤ¸
	      ret_val.push(@ip.eval("set err_msg"))
	    end
	  }
	}

	# Ǥ⥨顼ʤ
	l = (ret_val | []).size
	if l == 1 or ret_val.size == l
	  # ͤ 1 Τ or ۤʤ  ȤȰȤʤȿ
	  return cmd, 'not-proc', []
	end
      end

      # 
      if @verbose
	print "####### args of cmd '", cmd, "' are unknown. (ignore)\n"
      end
      return cmd, 'not-proc', nil
    end
  end

  # ޥɤΥפĴ٤
  def chk_tcltk_cmd_type(cmd, type, arg_info)
    # Ĥ
    return "general-cmd" unless arg_info && arg_info != []

    # ɬܰ¤Ӥ (  1 ϥåȥѥˤϤʤ )
    test_arg = []
    arg_info.each_with_index{|arg,cnt| 
      p arg if @verbose == 'DEBUG'
      next if arg.kind_of?(Array) 
      next if arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' Ͼάǽ
      test_arg.push("a#{cnt+1}")
    }
    print "#####", test_arg.inspect, "\n" if @verbose == 'DEBUG'

    # ɬܰʤ  åȥ饹ޥɤǤϤʤ
    unless test_arg
      return "general-cmd"
    end

    # ¹Ԥߤ ( åȥ饹ޥɤʤ饨顼ˤʤϤ )
    if @verbose == 'DEBUG'
      print "catch {#{cmd} #{test_arg.join(' ')}} err_msg\n"
    end
    if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
      # 顼ȯʤ
      return "general-cmd"
    end

    # 顼åΥå
    err_msg = @ip.eval("set err_msg")
    print "#####", err_msg, "\n" if @verbose == 'DEBUG'
    unless err_msg =~ /bad window path name "a(\d+)"/
      # ¿ʬåȥ饹ޥɤǤϤʤ
      return "general-cmd"
    end

    # ǽΰФƤΥɥѥ顼
    err_arg = $1.to_i
    if err_arg != 1
      # 㤦  ¿ʬåȤФϤΥޥ
      return "widget-control:#{err_arg}"

=begin # X Υ顼ߤƤޤǽ뤿ᡤΥƥȤ̵
      # ƥѤ˥ȥåץ٥륦åȤ
      @ip.eval("toplevel .tmp_toplevel")
      begin
	test_arg[err_arg - 1] = '.tmp_toplevel'
	print "#####",cmd," ",test_arg.join(' '),"\n" if @verbose == 'DEBUG'
	if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
	  # 顼ȯʤ
	  #   ¿ʬȥåץ٥륦åȤ˸¤äϤΥޥ
	  return "toplevel-control:#{err_arg}"
	else
	  # ¿ʬ̤ΥåȤФϤΥޥ
	  return "widget-control:#{err_arg}"
	end
      ensure
	# ȥåץ٥륦åȤμ¤˾õƤ
	@ip.eval("destroy .tmp_toplevel")
      end
=end
    end

    # åȥ󥹥󥹥ޥɤ뤫
    test_arg[0] = '.tmp_widget'
    #@ip.eval("destroy #{test_arg[0]}") ; # ǰΤᡤdestroy Ƥ
    @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
	     + "{destroy .tmp_widget}")
    print "#####", test_arg.inspect, "\n" if @verbose == 'DEBUG'
    print "#####", test_arg.join(' '), "\n" if @verbose == 'DEBUG'
    if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") == "1"
      # 顼ȯ
=begin # X Υ顼ߤƤޤǽ뤿ᡤΥƥȤ̵
	 # ¾ΰθ꤫
	 #   ¸ߤ륦åȤˤơ
	 #     άǽɲäƻߤ
	 begin
	   @ip.eval('frame .tmp_widget')
	   test_arg << '-?' if test_arg.size != arg_info.size
	   if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") == "1"
	     # 顼ȯ  顼åΥå
	     err_msg = @ip.eval("set err_msg")
	     print "#####", err_msg, "\n" if @verbose == 'DEBUG'
	     if err_msg =~ /("|).tmp_widget("|)\salready\sexist/
	       # ¿ʬåȥ饹ޥ
	       return "widget-class-cmd"
	     end
	   end
	 ensure
	   @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
		    + "{destroy .tmp_widget}")
	 end
=end
      # ¿ʬåȥ饹ޥɤǤϤʤ
      # ¿ʬ̤ΥåȤФϤΥޥ
      return "widget-control:1"

=begin # X Υ顼ߤƤޤǽ뤿ᡤΥƥȤ̵
	 # ƥѤ˥ȥåץ٥륦åȤ
	 @ip.eval("toplevel .tmp_toplevel")
	 begin
	   test_arg[0] = '.tmp_toplevel'
	   print "#####", cmd, " ", test_arg.join(' '), "\n"; STDOUT.flush
	   if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
	     # 顼ȯʤ
	     #   ¿ʬȥåץ٥륦åȤ˸¤äϤΥޥ
	     return "toplevel-control:1"
	   else
	     # ¿ʬ̤ΥåȤФϤΥޥ
	     return "widget-control:1"
	   end
	 #rescue GlobalExit
	 rescue Exception
	   # ͽ¬ʤ顼
	   #   ¿ʬȥåץ٥륦åȤ˸¤äϤΥޥ
	   return "toplevel-control:1"
	 ensure
	   # ȥåץ٥륦åȤμ¤˾õƤ
	   @ip.eval("destroy .tmp_toplevel")
	 end
=end
    end
    ret = @ip.eval("info commands .tmp_widget")
    print "###### #{ret}\n" if @verbose == 'DEBUG'
    if ret == '.tmp_widget'
      # ޥɤ줿  ¿ʬåȥ饹ޥ
      @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
	       + "{destroy .tmp_widget}")
      "widget-class-cmd"
    else
      # ¿ʬåȥ饹ޥɤǤϤʤ
      # ¿ʬåȤФϤΥޥ
      "widget-control:1"
    end
  end

  # ̥ޥɤΰǽץĴ٤
  def _get_general_cmd_opt_info(cmd, arg_info, cmd_type)
    if @verbose == 'DEBUG'
      print "### general: ",@ip.inspect, ' ', cmd, ' ', arg_info.inspect, "\n"
    end

    # ɬܰ¤Ӥ
    test_arg = []
    arg_info.each_with_index{|arg,cnt| 
      p arg if @verbose == 'DEBUG'
      next if arg.kind_of?(Array) 
      next if arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' Ͼάǽ
      test_arg.push("a#{cnt+1}")
    }

    # оݰ֤
    arg_pos = 1 ;#  1 

    # оݰ
    if test_arg[arg_pos - 1] != "a#{arg_pos}"
      #  1 ϡ¿ʬ switch
      test_param = '-\?'
      test_arg.unshift('-?')
    else
      #  1 άǽʤ顤¿ʬ switch ǤϤʤ
      test_param = '\?'
      test_arg[arg_pos - 1] = '?'
    end

    # ޥɤΥƥȼ¹
    if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
      # 顼ȯʤ  ץϻʤ
      return []
    end

    # 顼åΥå
    err_msg = @ip.eval("set err_msg")
    print "#####", cmd, " : ", err_msg, "\n" if @verbose == 'DEBUG'
    if err_msg !~ /^\s*(?:bad|unknown|unknown or ambiguous)\s+(opt|arg|switch)\S*\s+"#{test_param}"\s*(?::|,|\.)\s*(?:must|should)\s+be\s+(.+)$/i
      # ץΥ顼Ȥͽ¬ɽǤϤʤ
      if err_msg =~ /bad window path name "-\?"/
	# ¿ʬåȥ饹ޥ  פѹ
	if @verbose == 'DEBUG'
	  print "#####", cmd, " : type change to widget-control\n"
	end
	cmd_type.replace("widget-control:1")
	return false
      else
	# ץʤ
	return []
      end
    end
    print "##### MATCH!!!\n" if @verbose == 'DEBUG'
    opt_type = $1
    # ζΥԥꥪɤϼʸ¤Ӥ 1 ʸˤޤȤ
    opt_string = $2.strip.chomp('.').strip.squeeze(" \t") 

    # ǽץ˴ؤåβ
    opt_val_array = opt_string.split(/\s*(?:,(?!\s*or\s)|,\s*or\s|\sor\s)\s*/)

    show_type = (( opt_val_array.find{|opt| opt =~ /^('|"|\?).*\1$/ } )? 1: 0)
    opt_info = opt_val_array.collect{|opt|
      if show_type == 1
	(opt =~ /^('|"|\?)(.*)\1$/)? ['string', $2]: ['type', opt]
      else
	(opt.index(/\s/))? ['type', opt]: ['string', opt]
      end
    }

    # option switch 
    opt_type = 'switch'
    opt_info.each{|t,s| 
      if (t != 'string' || s[0] != ?- )
	opt_type = 'option'
	break
      end
    }
    p opt_type if @verbose == 'DEBUG'
    p opt_info if @verbose == 'DEBUG'

    # ֤ͤ
    [arg_pos, opt_type, opt_info]
  end


  # åϥޥɥץĴ㳰饹
  class WidgetClassError < Exception; end
  class CannotGenerateWidget < Exception; end

  # åϤΥޥɤΰǽץĴ٤
  def _get_widget_control_opt_info(cmd, arg_info, cmd_type, widget_arg)
    if @verbose == 'DEBUG'
      print "### control:",@ip,' ',cmd,"(#{widget_arg}) ",arg_info.inspect,"\n"
    end

    # ɬܰ¤Ӥ
    test_arg = []
    arg_info.each_with_index{|arg,cnt| 
      p arg if @verbose == 'DEBUG'
      next if arg.kind_of?(Array) 
      next if arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' Ͼάǽ
      test_arg.push("a#{cnt+1}")
    }

    # åȥѥ
    widget_path = '.tmp_widget'
    test_arg[widget_arg - 1] = widget_path

    # оݰ֤
    arg_pos = 1 ;#  1 
    arg_pos += 1 if (arg_pos == widget_arg) 

    # оݰ
    if test_arg[arg_pos - 1] != "a#{arg_pos}"
      test_arg[arg_pos - 1, 0] = '-?'
    else
      test_arg[arg_pos - 1] = '-?'
    end
    print "#####", cmd, ' ', test_arg.inspect, "\n" if @verbose == 'DEBUG'

    # ޥɤΥƥȼ¹
    widget_class = 'frame'
    begin
      @ip.eval("#{widget_class} #{widget_path}")
      if (@ip.eval("info commands #{widget_path}") != widget_path)
	raise CannotGenerateWidget, 
	  "fail to generate a widget of widget_class '#{widget_class}'"
      end
      if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
	# 顼ȯʤ  ץϻʤ
	return []
      end
      # 顼åγ
      err_msg = @ip.eval("set err_msg")
      if err_msg =~ /^#{widget_path} is not a (\w+)/
	widget_class = $1
	raise WidgetClassError, "widget_class must be '#{widget_class}'"
      end
    rescue WidgetClassError
      p $! if @verbose == 'DEBUG'
      @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
	       + "{destroy .tmp_widget}")
      retry
    rescue CannotGenerateWidget
      p $! if @verbose == 'DEBUG'
    ensure
      @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
	       + "{destroy .tmp_widget}")
    end

    # 顼åΥå
    print "#####", cmd, " : ", err_msg, "\n" if @verbose == 'DEBUG'
    if err_msg !~ /^\s*(?:bad|unknown|unknown or ambiguous)\s+(opt|arg|switch)\S*\s+"-\?"\s*(?::|,|\.)\s*(?:must|should)\s+be\s+(.+)$/i
      # ץΥ顼Ȥͽ¬ɽǤϤʤ
      print "##### NOT MATCH!!!\n" if @verbose == 'DEBUG'
      if err_msg =~ /("|).tmp_widget("|)\salready\sexist/
	# ¿ʬåȥ饹ޥ  פѹ
	if @verbose == 'DEBUG'
	  print "#####", cmd, " : type change to widget-class-cmd\n"
	end
	cmd_type.replace("widget-class-cmd")
	return false
      else
	# ץʤ
	return []
      end
    end
    print "##### MATCH!!!\n" if @verbose == 'DEBUG'
    opt_type = $1
    # ζΥԥꥪɤϼʸ¤Ӥ 1 ʸˤޤȤ
    opt_string = $2.strip.chomp('.').strip.squeeze(" \t") 

    # ǽץ˴ؤåβ
    opt_val_array = opt_string.split(/\s*(?:,(?!\s*or\s)|,\s*or\s|\sor\s)\s*/)

    show_type = (( opt_val_array.find{|opt| opt =~ /^('|"|\?).*\1$/ } )? 1: 0)
    opt_info = opt_val_array.collect{|opt|
      if show_type == 1
	(opt =~ /^('|"|\?)(.*)\1$/)? ['string', $2]: ['type', opt]
      else
	(opt.index(/\s/))? ['type', opt]: ['string', opt]
      end
    }

    # option switch 
    opt_type = 'switch'
    opt_info.each{|t,s| 
      if (t != 'string' || s[0] != ?- )
	opt_type = 'option'
	break
      end
    }
    p opt_type if @verbose == 'DEBUG'
    p opt_info if @verbose == 'DEBUG'

    # ֤ͤ
    [arg_pos, opt_type, opt_info]
  end

  # åȥ饹ޥɤΰǽץĴ٤
  def _get_widget_class_opt_info(cmd, arg_info)
    if @verbose == 'DEBUG'
      print "### wdgt_class: ",@ip.inspect,' ',cmd,' ',arg_info.inspect,"\n"
      print "### wdgt_class: ",cmd,' ',arg_info.inspect,"\n"
    end

    begin
      # åȤ
      if @ip.eval("catch {#{cmd} .tmp_widget} err_msg") == '1'
	# 顼ȯ  ŬڤͿʤǤʤ
	err_msg = @ip.eval("set err_msg")
	p "########################## #{err_msg}" if @verbose == 'DEBUG'
	return nil
      end

      # ץγ
      if @ip.eval('catch {.tmp_widget ?} err_msg') != '1'
	# 顼ȯʤ  ץʤ
	op_opt = []
      else
	# 顼åץ
	err_msg = @ip.eval("set err_msg")
	if err_msg !~ /^\s*(?:bad|unknown|unknown or ambiguous)\s+opt\S*\s+"\?"\s*(?::|,|\.)\s*(?:must|should)\s+be\s+(.+)$/i
	  # ץΥ顼Ȥͽ¬ɽǤϤʤ
	  print "##### NOT MATCH!!!\n" if @verbose == 'DEBUG'
	  # ץǽ
	  op_opt = []
	else
	  print "##### MATCH!!!\n" if @verbose == 'DEBUG'
	  # ǽץ˴ؤåβ
	  op_opt = $1.strip.chomp('.').strip.squeeze(" \t")\
	                  .split(/\s*(?:,(?!\s*or\s)|,\s*or\s|\sor\s)\s*/) \
 	                  .collect{|opt| (opt =~ /^('|"|\?)(.*)\1$/)? $2: opt}

	  # 'cget'  'configure' ȤϾʤ (Ѿ뤿)
	  op_opt.delete('cget')
	  op_opt.delete('configure')
	end
      end

      # °ץγ
      opt_string = @ip.eval('set opt_list [.tmp_widget configure]')
      opt_max = @ip.eval('llength $opt_list').to_i - 1
=begin
	 opt_array = (0..opt_max).collect {|opt_num|
	  elem_max = @ip.eval("llength [lindex $opt_list #{opt_num}]").to_i - 1
	  (0..elem_max).collect {|elem_num|
	    @ip.eval("lindex [lindex $opt_list #{opt_num}] #{elem_num}")
	  }
	}
	 p "#########################"
	 print opt_string,"\n"
	 opt_array.each{|opt| p opt}
=end
      cnf_opt = (0..opt_max).collect {|opt_num|
	elem_max = @ip.eval("llength [lindex $opt_list #{opt_num}]").to_i - 1
	(0..elem_max).collect {|elem_num|
	  @ip.eval("lindex [lindex $opt_list #{opt_num}] #{elem_num}")
	}
      }

    ensure
      @ip.eval("if {\"x[info commands .tmp_widget]\"!={x}} " \
	       + "{destroy .tmp_widget}")
    end

    return op_opt, cnf_opt
  end

  # switch άǽ̾ȸ򤷤Ƥβ
  def cmd_switch_args_check(cmd, proc_type, arg_info, cmd_type)
    # arg_info ǤƤʤ̵
    return false unless arg_info

    # switch ȤĴ٤ΤƬΰΤߤȤ
    # ƬάǽǤʤ switch ǤϤʤ
    return false unless arg_info[0].kind_of?(Array)

    new_args = []
    sw = []
    arg_info.each_with_index{|arg,idx|
      unless arg.kind_of?(Array)
	new_args = arg_info[idx..-1]
	break
      end

      sub_arg = arg.dup
      while sub_arg != []
	# 1 Ф
	a,v = sub_arg.shift

	# switch 
	if a[0] != ?-
	  # switch ǤϤʤ
	  sub_arg.unshift([a,v])
	  break
	end

	# switch ȿ  switch ꥹȤɲ
	sw << a
      end

      if sub_arg != []
	new_args << sub_arg 
	new_args = new_args + arg_info[(idx+1)..-1]
	break
      end
    }

    # switch ¸ߤ뤫
    return false if sw == []

    # ¸ߤ  arg_info ִ
    arg_info.replace([ [['switch', nil]] ] + new_args)

    # switch ֤
    [ 1, 'switch', sw.collect{|s| ['string', s]} ]
  end

  # ޥɤΰǽץ ( or ֥ޥ ) Ĵ٤
  def get_cmd_option_info(cmd, proc_type, arg_info, cmd_type)
    # Ĥ
    return [] unless arg_info && arg_info != []

    # ޥɥפ˴Ť
    case cmd_type
    when 'general-cmd'
      _get_general_cmd_opt_info(cmd, arg_info, cmd_type)
    when /widget-control:(\d+)/
      _get_widget_control_opt_info(cmd, arg_info, cmd_type, $1.to_i)
    when 'widget-class-cmd'
      _get_widget_class_opt_info(cmd, arg_info)
    end
  end

  # switch İ̥ޥɤǽץ ( or ֥ޥ ) Ĵ٤
  def get_gencmd_opt_with_switch (cmd, proc_type, arg_info, cmd_type, opt_info)
    if @verbose == 'DEBUG'
      print "### general-with-switch: ",@ip.inspect, ' ', 
	cmd, ' ', arg_info.inspect, "\n"
    end

    # ɬܰ¤Ӥ
    test_arg = []
    arg_info.each_with_index{|arg,cnt| 
      p arg if @verbose == 'DEBUG'
      next if arg.kind_of?(Array) 
      next if arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' Ͼάǽ
      test_arg.push("a#{cnt+1}")
    }

    # оݰ
    arg_pos = test_arg[0][1..-1].to_i ;# ǽξάǽ
    test_arg[0] = '?'

    # ޥɤΥƥȼ¹
    if @ip.eval("catch {#{cmd} #{test_arg.join(' ')}} err_msg") != "1"
      # 顼ȯʤ  ץϻʤ
      return false
    end

    # 顼åΥå
    err_msg = @ip.eval("set err_msg")
    print "#####", cmd, " : ", err_msg, "\n" if @verbose == 'DEBUG'
    if err_msg !~ /^\s*(?:bad|unknown|unknown or ambiguous)\s+(opt|arg)\S*\s+"\?"\s*(?::|,|\.)\s*(?:must|should)\s+be\s+(.+)$/i
      # ץΥ顼Ȥͽ¬ɽǤϤʤ
      return false
    end
    print "##### MATCH!!!\n" if @verbose == 'DEBUG'
    opt_type = $1
    # ζΥԥꥪɤϼʸ¤Ӥ 1 ʸˤޤȤ
    opt_string = $2.strip.chomp('.').strip.squeeze(" \t") 

    # ǽץ˴ؤåβ
    opt_val_array = opt_string.split(/\s*(?:,(?!\s*or\s)|,\s*or\s|\sor\s)\s*/)

    show_type = (( opt_val_array.find{|opt| opt =~ /^('|"|\?).*\1$/ } )? 1: 0)
    opt_info = opt_val_array.collect{|opt|
      if show_type == 1
	(opt =~ /^('|"|\?)(.*)\1$/)? ['string', $2]: ['type', opt]
      else
	(opt.index(/\s/))? ['type', opt]: ['string', opt]
      end
    }

    # option switch 
    opt_type = 'switch'
    opt_info.each{|t,s| 
      if (t != 'string' || s[0] != ?- )
	opt_type = 'option'
	break
      end
    }
    p opt_type if @verbose == 'DEBUG'
    p opt_info if @verbose == 'DEBUG'

    # ֤ͤ
    if opt_type == 'switch'
      false
    else
      [arg_pos, opt_type, opt_info]
    end
  end

  # åȤǽץ޴ط
  def get_relation_of_widget_option (subcmd_set_diff, opt_set_diff, cmd_set)
    # Ʊץĥޥɤν
    chk_flag = Hash.new
    same_set = Hash.new
    cmd_set.each{|cmd1|
      chk_flag[cmd1] = false
      same_set[cmd1] = Array.new
      cmd_set.each{|cmd2|
	if (subcmd_set_diff[cmd1][cmd2] == [] \
	    && subcmd_set_diff[cmd2][cmd1] == [] \
	    && opt_set_diff[cmd1][cmd2] == [] \
	    && opt_set_diff[cmd2][cmd1] == [])
	  same_set[cmd1] << cmd2
	end
      }
      same_set[cmd1].sort!
    }

    # ޴طĴ
    ret = []
    cmd_set.each{|cmd1|
      next if chk_flag[cmd1]
      same_set[cmd1].each{|c| chk_flag[c] = true}
      non_sub = true
      sup = []
      cmd_set.each{|cmd2|
	next if same_set[cmd1].include?(cmd2)
	#sup << cmd2 if opt_set_diff[cmd2][cmd1] == []
	#non_sub = false if opt_set_diff[cmd1][cmd2] == []
	sup << cmd2 if (subcmd_set_diff[cmd2][cmd1] == [] \
			&& opt_set_diff[cmd2][cmd1] == [])
	non_sub = false if (subcmd_set_diff[cmd1][cmd2] == [] \
			    && opt_set_diff[cmd1][cmd2] == [])
      }
      ret << [(same_set[cmd1].size == 1)? cmd1: same_set[cmd1], 
	      get_relation_of_widget_option(subcmd_set_diff, opt_set_diff, 
					    sup )] if non_sub
    }
    ret
  end

  # ޥ̾ʸˤ륯饹ؾǤξ̴̲ط
  # ( ޤǤ⡤ץ޴طǤηǽʬФ )
  def get_relation_of_cmd_name(cmd1, cmd2)
    # ٥
    lvl = 0

    # ʸʸΰ㤤Τߤ
    return lvl if cmd1 =~ /^#{cmd2}$/i

    # capitalize , _ ˤɶʬǥޥʸʬ
    # () asdf_FileVList00 => ["asdf", "File", "V", "List", "00"]
    cmp1_w = cmd1.split(/(?:(?=[A-Z])|_|-|(\d+))/)
    cmp2_w = cmd2.split(/(?:(?=[A-Z])|_|-|(\d+))/)

    # ¾ (ʸʸϤΤޤ)  word ɲäΤ
    lvl += 1
    if cmp1_w.size > cmp2_w.size
      words = cmp1_w.dup
      words << '' # ߡ
      cmp2_w.each {|w|
	words.shift while words != [] && w != words[0]
	break if words == []
	words.shift
      }
      return -lvl if words != []
    end
    if cmp2_w.size > cmp1_w.size
      words = cmp2_w.dup
      words << '' # ߡ
      cmp1_w.each {|w|
	words.shift while words != [] && w != words[0]
	break if words == []
	words.shift
      }
      return  lvl if words != []
    end

    # ¾ word ά word ɲäΤ
    # word άǤϡƬϾάƤʤΤȤ
    lvl += 1
    diff12 = cmp1_w - cmp2_w
    diff21 = cmp2_w - cmp1_w
    if diff12.size > diff21.size
      diff12 << '' # ߡ
      diff21.each {|w|
	while diff12 != []
	  if w.length == diff12[0].length
	    diff12.shift
	    next
	  end
	  if w.length < diff12[0].length
	    pat = w.split('').collect!{|c|c=~/[$?*^+-.\\]/? '\\'+c: c} \
                             .join('.*')
	    break if diff12[0] =~ /^#{pat}.*$/i
	  else
	    pat = diff12[0].split('') \
	                .collect!{|c| c=~/[$?*^+-.\\]/? '\\'+c: c}.join('.*')
	    break if w =~ /^#{pat}.*$/i
	  end
	  diff12.shift 
	end
	break if diff12 == []
	diff12.shift
      }
      return -lvl if diff12 != []
    elsif diff21.size > diff12.size
      diff21 << '' # ߡ
      diff12.each {|w|
	while diff21 != []
	  if w.length == diff21[0].length
	    diff21.shift
	    next
	  end
	  if w.length < diff21[0].length
	    pat = w.split('').collect!{|c|c=~/[$?*^+-.\\]/? '\\'+c: c} \
                             .join('.*')
	    break if diff21[0] =~ /^#{pat}.*$/i
	  else
	    pat = diff21[0].split('') \
	                .collect!{|c| c=~/[$?*^+-.\\]/? '\\'+c: c}.join('.*')
	    break if w =~ /^#{pat}.*$/i
	  end
	  diff21.shift 
	end
	break if diff21 == []
	diff21.shift
      }
      return  lvl if diff21 != []
    end

    # ¾ (ʸʸϤΤޤ) ʸɲäΤ
    lvl += 1
    pat1 = cmd1.split('').collect!{|c| c=~/[$?*^+-.\\]/? '\\'+c: c}.join('.*')
    pat2 = cmd2.split('').collect!{|c| c=~/[$?*^+-.\\]/? '\\'+c: c}.join('.*')
    return -lvl if cmd1 =~ /^.*#{pat2}.*$/   # cmd1  cmd2 + 
    return  lvl if cmd2 =~ /^.*#{pat1}.*$/   # cmd2  cmd1 + 

    # ¾ (ʸʸΰ㤤̵) ʸɲäΤ
    lvl += 1
    return -lvl if cmd1 =~ /^.*#{pat2}.*$/i  # cmd1  cmd2 + 
    return  lvl if cmd2 =~ /^.*#{pat1}.*$/i  # cmd2  cmd1 + 

    # '[A-Z][a-z0-9]*' < 'Widget'
    lvl += 1
    if cmd2 =~ /widget$/i
      return -lvl if cmd1 =~ /^#{$`}[A-Z][a-z0-9]*$/i
    end
    if cmd1 =~ /widget$/i
      return  lvl if cmd2 =~ /^#{$`}[A-Z][a-z0-9]*$/i
    end

    # '.*' < 'Widget'
    lvl += 1
    if cmd2 =~ /widget$/i
      return -lvl if cmd1 =~ /^#{$`}.*$/i
    end
    if cmd1 =~ /widget$/i
      return  lvl if cmd2 =~ /^#{$`}.*$/i
    end

    # 'Window' < '[A-Z][a-z0-9]*'
    lvl += 1
    if cmd1 =~ /window$/i
      return -lvl if cmd2 =~ /^#{$`}[A-Z][a-z0-9]*$/i
    end
    if cmd2 =~ /window$/i
      return  lvl if cmd1 =~ /^#{$`}[A-Z][a-z0-9]*$/i
    end

    # 'Window' < '.*'
    lvl += 1
    if cmd1 =~ /window$/i
      return -lvl if cmd2 =~ /^#{$`}.*$/i
    end
    if cmd2 =~ /window$/i
      return  lvl if cmd1 =~ /^#{$`}.*$/i
    end

    # ̴̲طǽ (¿ʬΩȤ٤)
    return false
  end

  # åȤǽץ޴طɽ
  def disp_relation_of_widget_option(rel, depth)
    return if rel == []
    spc = '    ' * depth
    rel.each{|cmd, sup_rel|
      if cmd.kind_of?(Array)
	print spc,cmd.inspect,"\n"
	cmd.each{|c| @cmd_rel_checked[c] = true}
      else
	print spc,cmd,"\n"
	@cmd_rel_checked[cmd] = true
      end
      disp_relation_of_widget_option(sup_rel, depth + 1)
    }
  end

  # åȥ饹ؤɽ
  def disp_widget_class_relation(rel, depth)
    return if rel == []
    spc = '    ' * depth
    cmd, sup_rel = rel
    if cmd.kind_of?(Array)
      print spc,cmd.inspect,"\n"
      cmd.each{|c| @cmd_rel_checked[c] = true}
    else
      print spc,cmd,"\n"
      @cmd_rel_checked[cmd] = true
    end
    disp_widget_class_relation(sup_rel, depth + 1)
  end

  def _estimate_rel_step1_sub(cmd_list, same = nil)
    return [] unless cmd_list && cmd_list != []

    # طơ֥
    rel_tbl  = {}
    cmd_list.each{|cmd1|
      rel_tbl[cmd1]  = {}
      cmd_list.each{|cmd2|
	rel_tbl[cmd1][cmd2] = get_relation_of_cmd_name(cmd1, cmd2)
      }
    }

    if same == nil
      # Ʊ쥳ޥɤ
      dels = []
      same = {}
      cmd_list.each{|cmd1|
	same[cmd1] = []
	cmd_list.each{|cmd2|
	  if rel_tbl[cmd1][cmd2] == 0 && cmd1 < cmd2
	    dels << cmd2
	    same[cmd1] << cmd2
	    cmd_list.each{|cmd3|
	      if (rel_tbl[cmd1][cmd3] == false \
		  || (rel_tbl[cmd2][cmd3] \
		      && rel_tbl[cmd2][cmd3].abs < rel_tbl[cmd1][cmd3].abs) )
		rel_tbl[cmd1][cmd3] = rel_tbl[cmd2][cmd3]
	      end
	    }
	  end
	}
      }
      dels.each{|cmd| rel_tbl.delete(cmd)}
    end

    # ѡ饹ʤΤꥹȥå
    top = \
    rel_tbl.keys.find_all{|cmd1|
      if rel_tbl.keys.find{|cmd2| 
	  rel_tbl[cmd1][cmd2] != false && rel_tbl[cmd1][cmd2] > 0
	}
	false
      else
	true
      end
    }

    # ֥饹Ĵ
    subs = top.collect{|cmd1|
      sub_list = rel_tbl.keys.find_all{|cmd2| 
	rel_tbl[cmd1][cmd2] != false && rel_tbl[cmd1][cmd2] < 0
      }
      [cmd1, _estimate_rel_step1_sub(sub_list, same)]
    }

    # ʣκ
    dels = []
    subs.each{|cmd, sub|
      cmds = sub.flatten
      top.each{|c|
	dels << c if (c != cmd && cmds.include?(c))
      }
    }
    subs.delete_if{|cmd, sub| dels.include?(cmd)}

    # Ʊ쥳ޥɤͿ
    subs.collect!{|cmd, sub| 
      if same[cmd] != [] 
	[[cmd] + same[cmd], sub]
      else
	[cmd, sub]
      end
    }
  end

  def _estimate_rel_step1(rel)
    rel.collect!{|cmd, sup_rel|
      if cmd.kind_of?(Array)
	cmd = _estimate_rel_step1_sub(cmd)
      end
      [cmd, _estimate_rel_step1(sup_rel)]
    }
  end

  def _estimate_rel_step2_sub(sub_cmd, rel)
    new_rel = nil
    flat_all = []

    # Ĥ꤬ʤʤФΤޤ֤
    if rel == []
      return [sub_cmd, rel], []
    end

    # ʣ饹ηѾηˤʤäƤ뤫
    if rel.size != 1
      # ̥ѡ饹
      cmdset = nil
      rel.each{|cmd, sup_rel|
	core, flat = _estimate_rel_step2_sub(cmd, sup_rel)
	flat_all << core
	flat.each{|s| flat_all << s}
	if cmdset == nil
	  cmdset = core.flatten
	else
	  cmdset &= core.flatten
	end
      }
      # ̥ѡ饹ѾȤƻĤ
      if cmdset == []
	new_rel = [sub_cmd, []]
      else
	srch = rel[0]
	while srch && srch != []
	  cmd, sup_rel = srch
	  if cmdset.include?(cmd)
	    new_rel = [sub_cmd, srch]
	    break
	  end
	  srch = sup_rel[0]
	end
	if new_rel == nil
	  raise RuntimeError, "new_rel error0"
	end
      end

      # 줿ʬν
      _estimate_rel_step2(rel).each{|s| flat_all << s}

    else
      # ѡ饹 1 
      cmd, sup_rel = rel[0]
      if sup_rel == []
	# ؤΥȥå
	if new_rel != nil 
	  raise RuntimeError, "new_rel error1"
	else
	  new_rel = [sub_cmd, [cmd, sup_rel]]
	end

      elsif cmd.kind_of?(Array)
	# ʣ䤬¸  ̾鸫ơ̤äݤΤ
	max_val = -999
	direct_sup_cmds = []

	cmd.each{|sup_cmd, supsup_cmds|
	  c1 = sub_cmd.kind_of?(Array)? sub_cmd[0]: sub_cmd
	  c2 = sup_cmd.kind_of?(Array)? sup_cmd[0]: sup_cmd
	  rel_val = get_relation_of_cmd_name(c1, c2)
	  next unless rel_val && rel_val < 0
	  if rel_val == max_val
	    direct_sup_cmds << sup_cmd
	  elsif rel_val > max_val
	    max_val = rel_val
	    direct_sup_cmds = [sup_cmd]
	  end
	}

	if direct_sup_cmds == []
	  # ̾鸫ơ̤äݤΤʤ  ʤΤ 1 ٥ѥ
	  cmd.each{|sup_cmd, supsup_cmds|
	    ss = (supsup_cmds == [])? sup_cmd: [sup_cmd, supsup_cmds]
	    flat_all << [ss, sup_rel]
	  }
	  core, flat = _estimate_rel_step2_sub(sub_cmd, sup_rel)
	  if new_rel != nil 
	    raise RuntimeError, "new_rel error1"
	  else
	    new_rel = core
	  end
	  flat.each{|s| flat_all << s}
	  # [ core, flat_all ]

	else
	  # ̾鸫ơ̤äݤΤ¸
	  if direct_sup_cmds.size == 1
	    # ̤餷Ǥ⤤Τ 1 Ĥ
	    ss = nil
	    cmd.each{|sup_cmd, supsup_cmds|
	      if sup_cmd == direct_sup_cmds[0]
		ss = (supsup_cmds == [])? sup_cmd: [sup_cmd, supsup_cmds]
	      else
		flat_all << [sup_cmd, [supsup_cmds, sup_rel] ] 
	      end
	    }
	    if new_rel != nil 
	      raise RuntimeError, "new_rel error2"
	    else
	      new_rel = [sub_cmd, [ss, sup_rel]]
	    end
	    # [ [sub_cmd, [ss, sup_rel]], flat_all ]
	  else
	    # ̤餷Ǥ⤤Τʣ¸
	    # ǽ  ʤΤǡʸĹǤᤤΤˤƤ(^_^;
	    l = sub_cmd.length
	    s = direct_sup_cmds.min{|x,y|
	      (x.length - l).abs <=> (y.length - l).abs
	    }
	    ss = nil
	    cmd.each{|sup_cmd, supsup_cmds|
	      if sup_cmd == s
		ss = (supsup_cmds == [])? sup_cmd: [sup_cmd, supsup_cmds]
	      else
		flat_all << [sup_cmd, [supsup_cmds, sup_rel]]
	      end
	    }
	    if new_rel != nil 
	      raise RuntimeError, "new_rel error3"
	    else
	      new_rel = [sub_cmd, [ss, sup_rel]]
	    end
	    # [ [sub_cmd, [ss, sup_rel]], flat_all ]
	  end
	end

      else
	#  1 Ĥ
	core, flat = _estimate_rel_step2_sub(cmd, sup_rel)
	if new_rel != nil 
	  raise RuntimeError, "new_rel error4"
	else
	  new_rel = [sub_cmd, core]
	end
	flat.each{|s| flat_all << s}
	# [ [sub_cmd, core], flat ]
      end
    end

    # 줿ع¤ü饹Ȥ٤ΤΥꥹȤȤ֤
    return new_rel, flat_all
  end

  def _estimate_rel_step2(rel)
    # ü饹ν
    non_flat = []
    new_rel = []
    flat_all = []

    rel.each{|cmd, sup_rel|
      if sup_rel == []
	# ѡ饹ʤ
	if cmd.kind_of?(Array)
	  cmd.each{|c| new_rel << [c, sup_rel]}
	else
	  new_rel << [cmd, sup_rel]
	end

      elsif cmd.kind_of?(Array)
	# Ʊ쥪ץʣޥ
	cmd.each{|sup_cmd, supsup_cmds|
	  core, flat = _estimate_rel_step2_sub(sup_cmd, sup_rel)
	  core.flatten.each{|c| non_flat << c}
	  if supsup_cmds != []
	    s = core.shift
	    core.unshift([s, supsup_cmds])
	  end
	  new_rel << core
	  flat.each{|s| flat_all << s}
	}

      else
	# ñ
	core, flat = _estimate_rel_step2_sub(cmd, sup_rel)
	new_rel << core
	flat.each{|s| flat_all << s}
      end

      # ü饹ȤƤɲ
      flat_all.each{|c,r|
	if c.kind_of?(Array)
	  c = c[0]
	end
	next if non_flat.include?(c)
	new_rel << [c,r]
      }
    }

    # 줿ع¤֤
    new_rel
  end

  def _estimate_rel_step3_relsub(rel)
    if rel == [] || rel == nil
      []
    else
      if rel.size == 1
	if rel[0].kind_of?(Array)
	  _estimate_rel_step3_relsub(rel[0])
	else
	  [rel, []]
	end
      else
	_estimate_rel_step3_cmdsub(rel[0], rel[1])
      end
    end
  end

  def _estimate_rel_step3_cmdsub(cmds, rel)
    if cmds.kind_of?(Array)
      if cmds == []
	_estimate_rel_step3_relsub(rel)
      elsif cmds.size == 1
	_estimate_rel_step3_cmdsub(cmds[0], rel)
      elsif cmds[1].kind_of?(String)
	[cmds, _estimate_rel_step3_relsub(rel)] ; # Ʊ̾
      else
	[cmds[0], _estimate_rel_step3_cmdsub(cmds[1], rel)]
      end
    else
      [cmds, _estimate_rel_step3_relsub(rel)]
    end
  end

  def _estimate_rel_step3(rel)
    return [] until rel && rel != []
    rel.collect!{|s|
      if s.size == 1
	_estimate_rel_step3(s[0])
      else
	_estimate_rel_step3_cmdsub(s[0], s[1])
      end
    }
  end

  def _estimate_rel_step4(rel)
    new_rel = []
    rel.each{|t1|
      next if rel.find{|t2| 
	t1.flatten - t2.flatten == [] && t2.flatten - t1.flatten != []
      }
      new_rel << t1 unless new_rel.find{|t2|
	t1.flatten - t2.flatten == [] && t2.flatten - t1.flatten == []
      }
    }
    new_rel
  end

  def extract_ambiguous_relation(rel)
    # Step 1 : ƱץΥޥɴ֤ξ̲̿
    _estimate_rel_step1(rel)

    # Step 2 : ¿¿ξ̲̤Ÿ
    rel = _estimate_rel_step2(rel)

    # Step 3 : פߤŸ
    rel = _estimate_rel_step3(rel)

    # Step 4 : ¾ʬڤΥ֥åȤȤʤäƤΤν
    rel = _estimate_rel_step4(rel)
  end

  # widget class tree ɽѤΥ֥롼
  def disp_widget_class_tree_sub(tree, cmd, depth)
    spc = '    ' * depth

    if cmd == '.' 
      # print "(top)"
      print "(TkWindow)"
    else
      print spc,cmd
    end

    aliases = tree.keys.find_all{|c| tree[c].kind_of?(String) && tree[c]==cmd}
    if aliases && aliases != []
      print '  ( ', aliases.join(', '), ' ) '
    end

    print "\n"

    subs = tree[cmd]
    return if subs == []

    subs.each{|c| disp_widget_class_tree_sub(tree, c, depth + 1)}
  end

  ##########################################################
  #  (׵ᤵ饤֥Ƴ)
  ##########################################################
  def initialize (pre_load_lib, verbose = false)
    @pre_load_lib = pre_load_lib
    @verbose = verbose

    ##########################################################
    # Ϥ sync 
    STDOUT.sync = true
    STDERR.sync = true

    ##########################################################
    print "\n# Tcl/Tk 󥿡ץ꥿\n" if verbose
    @ip = TclTkIp.new()

    ##########################################################
    # ƥޥɤθˤ widget βɽǾ¤ˤ
    @ip.eval('wm withdraw .')

    ##########################################################
    # ֤ϥե뤫ɤ߹फ
    return unless @pre_load_lib

    ##########################################################
    if verbose
      print "\n# оݤγĥ饤֥",
	    "ƳƤͤФʤʤ饤֥Ƴ\n"
      print "pre_load_lib = "
      p @pre_load_lib
    end
    @ip.setup_libs(*@pre_load_lib)

    ##########################################################
    print "\n# ĥ饤֥ƳΥޥɥꥹȤγ\n" if verbose
    @ip.realload_all_auto_load_cmds; # λǤΤ٤ƤΥޥɤ ip 
    @base_cmd_list_src = @ip.eval('info commands')
    print @base_cmd_list_src  if verbose == 'DEBUG'
    @base_cmd_list = @base_cmd_list_src.split(/\s+/).sort
    if verbose
      print "=======================================\n"
      p @base_cmd_list
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ĥ饤֥Ƴ namespace γ", 
          "( for Tcl8.0 over )\n"  if verbose
    @base_namespace = @ip.get_namespace
    if verbose
      print "base_namespace == "
      p @base_namespace
      print "=======================================\n"
    end

    ##########################################################
    print "\n# namespace Υޥɤγ ( for Tcl8.0 over )\n" if verbose
    @base_namespace.each{|namsp|
      cmds = @ip.eval("namespace eval #{namsp} {info commands}").split(/\s+/)
      cmds.collect!{|cmd|
	#@ip.eval("namespace eval #{namsp} {namespace origin #{cmd}}")
	@ip.eval("namespace eval #{namsp} {namespace origin #{cmd}}")\
	   .sub(/^::/,'')
      }
      @base_cmd_list += cmds
    }
    @base_cmd_list = (@base_cmd_list | []).sort
    if verbose
      p @base_cmd_list
      print "=======================================\n"
    end

    ##########################################################
  end

  ##########################################################
  # ʹߤΥ᥽åɤ public
  public

  ##########################################################
  # Tcl/Tk ĥѥå(饤֥)Ƴ
  ##########################################################
  def load_ext_library (ext_lib_info, verbose = false)
    @ext_lib_info = ext_lib_info
    @verbose = verbose

    ##########################################################
    print "\n# ĥ饤֥Ƴ\n"  if verbose
    print "ext_lib_info = " if verbose
    p @ext_lib_info  if verbose
    @libname = @ip.full_load_libs(*@ext_lib_info)
    fail RuntimeError, "No library name" unless @libname
    print "\nloaded ext-package name = '", @libname, "'\n\n"  if verbose

    ##########################################################
    print "\n# ĥ饤֥ƳΥޥɥꥹȤγ\n"  if verbose
    @cmd_list_src = @ip.eval('info commands')
    print @cmd_list_src  if verbose == 'DEBUG'
    @cmd_list = @cmd_list_src.split(/\s+/).sort
    if verbose
      print "=======================================\n"
      p @cmd_list
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ĥ饤֥Ƴ namespace Υޥɤγ",
               " ( for Tcl8.0 over )\n"  if verbose
    @namespace = @ip.get_namespace
    if verbose
      print "namespace == "
      p @namespace
      print "=======================================\n"
    end
    @namespace.each{|namsp|
      cmds = @ip.eval("namespace eval #{namsp} {info commands}").split(/\s+/)
      cmds.collect!{|cmd|
	#@ip.eval("namespace eval #{namsp} {namespace origin #{cmd}}")
	@ip.eval("namespace eval #{namsp} {namespace origin #{cmd}}")\
	   .sub(/^::/,'')
      }
      @cmd_list += cmds
    }
    @cmd_list = (@cmd_list | []).sort
    if verbose
      p @cmd_list
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ĥ饤֥ƳΥޥɽκʬ\n"  if verbose
    @new_cmd_all = @cmd_list - @base_cmd_list
    if verbose
      print "@new_cmd_all = "
      p @new_cmd_all
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ':' ( ':'  1 ĤΤߡ'::'  namespace ȿ )  \n",
          "# '_' Ȥ褦ʥޥɤüʤΤȤƽ\n" if verbose
    @new_cmd_list = @new_cmd_all.dup.delete_if{|cmd|
      /^_/ === cmd or /[^:]:[^:]/ === cmd}
    if verbose
      print "new_cmd_list = "
      p @new_cmd_list
      print "=======================================\n"
      print "\n"
      print "=======================================\n"
      print "(new_cmd_all - new_cmd_list) = "
      p (@new_cmd_all - @new_cmd_list)
      print "=======================================\n"
    end

    ##########################################################
    # ѥå֤̾
    @libname
    ##########################################################
  end

  ##########################################################
  # Tcl/Tk ĥѥåǤɲåޥɸ
  ##########################################################
  def check_new_command (verbose = false)
    @verbose = verbose

    ##########################################################
    # ƥޥɤθ tkerror ɽߤ뤿ᡤ
    # tkerror κ򤪤ʤ
    @ip.eval('proc tkerror {args} ' \
	     + '{puts stderr "Error: [join $args { }]";return 0}')

    ##########################################################
    print "\n# ƥޥɤθ\n"  if verbose
    @new_cmd_args = @new_cmd_list.collect{|cmd| cmd_args_test(cmd)}
    if verbose
      print "=======================================\n"
      p @new_cmd_args
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ޥɥפθ\n#\n", 
          "# Ǥϡruby Υ顼Ȥϰۤʤ¿Υ顼å",
          "Ȼפ뤬\n",
          "# ϸTcl/Tk ¦ΤǤ뤿ᡤ",
          "̵̾뤷Ƥ褤\n"   if verbose
    @new_cmd_args.each_index {|idx|
      p @new_cmd_args[idx]  if verbose == 'DEBUG'
      next if @new_cmd_args[idx].size > 3 ;# ޤǤθκݤ˸
      @new_cmd_args[idx].push(chk_tcltk_cmd_type(*@new_cmd_args[idx]))
    }
    if verbose
      print "=======================================\n"
      @new_cmd_args.each{|item| p item}
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ޥɤΥץ ( or ֥ޥ ) γߤ\n#\n",
          "# Ǥϡruby Υ顼Ȥϰۤʤ¿Υ顼å",
          "Ȼפ뤬\n",
          "# ϸTcl/Tk ¦ΤǤ뤿ᡤ",
          "̵̾뤷Ƥ褤\n"  if verbose
    @new_cmd_args.each_index {|idx|
      next if @new_cmd_args[idx].size > 4 ;# ޤǤθκݤ˸
      ret = cmd_switch_args_check(*@new_cmd_args[idx])
      if ret == false
	['general-cmd','widget-control','widget-class-cmd'].each {|st|
	  ret = get_cmd_option_info(*@new_cmd_args[idx])
	  break if ret != false
	}
      end
      ret = [] if ret == false
      @new_cmd_args[idx].push(ret)
      if @new_cmd_args[idx][3] == 'general-cmd' && ret[1] == 'switch'
	ret = get_gencmd_opt_with_switch(*@new_cmd_args[idx])
	@new_cmd_args[idx].push(ret) if ret != false
      end
    }
    if verbose
      print "=======================================\n"
      @new_cmd_args.each{|item| p item}
      print "=======================================\n"
    end

    ##########################################################
    print "\n# åȥ󥹥󥹥ޥɤθ\n",
          "# åȥ󥹥󥹤ȤΥץ󽸹\n"  if verbose
    @subcmds  = Hash.new
    @cmd_opts = Hash.new
    @new_cmd_args.each {|cmd, proc_type, arg_info, cmd_type, cmd_opt|
      subcmds_info, opt_info = *cmd_opt
      if verbose == 'DEBUG'
	print "#AAA# #{cmd} #{arg_info.inspect} #{cmd_type}\n" unless opt_info
      end
      next if cmd_type != 'widget-class-cmd'
      next if opt_info == nil
      @subcmds[cmd]  = (subcmds_info | []).sort
      @cmd_opts[cmd] = (opt_info.collect{|str, name| name} | []).sort
      print "#XXX# #{cmd} #{cmd_opts[cmd].inspect} \n"  if verbose == 'DEBUG'
    }
    if verbose
      print "=======================================\n"
      @subcmds.each{|cmd,subs| print cmd,' => ',subs.inspect,"\n"}
      print "=======================================\n"
      print "\n"
      print "=======================================\n"
      @cmd_opts.each{|cmd,opts| print cmd,' => ',opts.inspect,"\n"}
      print "=======================================\n"
    end

    ##########################################################
    print "\n# åȥ󥹥󥹥֥ޥɽ",
          "޴طĴ\n" if verbose
    subcmd_set_diff = Hash.new
    @subcmds.each{|cmd1,subs1|
      subcmd_set_diff[cmd1] = Hash.new
      @subcmds.each{|cmd2,subs2| subcmd_set_diff[cmd1][cmd2] = subs1 - subs2}
    }

    ##########################################################
    print "\n# ץ󽸹޴طĴ\n" if verbose
    opt_set_diff = Hash.new
    @cmd_opts.each{|cmd1,opts1|
      opt_set_diff[cmd1] = Hash.new
      @cmd_opts.each{|cmd2,opts2| opt_set_diff[cmd1][cmd2] = opts1 - opts2 }
    }
    if verbose == 'DEBUG'
      @cmd_opts.each_key{|cmd2|
	top = true
	@cmd_opts.each_key{|cmd1| 
	  next if cmd1 == cmd2
	  if opt_set_diff[cmd1][cmd2] == []
	    print "#{cmd1} > #{cmd2}\n"
	    top = false
	  end
	}
	print "*** > #{cmd2}\n" if top
      }
      p @cmd_opts.keys.size
    end
    cmd_rel = get_relation_of_widget_option(subcmd_set_diff, opt_set_diff, 
					    @cmd_opts.keys)
    if verbose
      p cmd_rel  if verbose == 'DEBUG'
      @cmd_rel_checked = Hash.new
      @cmd_opts.each_key{|c| @cmd_rel_checked[c] = false}
      print "=======================================\n"
      disp_relation_of_widget_option(cmd_rel, 0)
      print "=======================================\n"
      print "( ʲϾüޥɤν  ⤷¸ߤ BUG )\n"
      print "---------------------------------------\n"
      @cmd_rel_checked.each{|c,v| p c unless v}
      print "=======================================\n"
    end

    ##########################################################
    print "\n# ץ󽸹޴طۣβ\n" if verbose
    @widget_rel = (extract_ambiguous_relation(cmd_rel) | [])

    if verbose
      if verbose == 'DEBUG'
	p @widget_rel
	print "=======================================\n"
	@widget_rel.each{|l| p l}
	print "=======================================\n"
      end
      @cmd_rel_checked = Hash.new
      @cmd_opts.each_key{|c| @cmd_rel_checked[c] = false}
      print "=======================================\n"
      @widget_rel.each{|l| disp_widget_class_relation(l, 0)}
      print "=======================================\n"
      print "( ʲϾüޥɤν  ⤷¸ߤ BUG )\n"
      print "---------------------------------------\n"
      @cmd_rel_checked.each{|c,v| p c unless v}
      print "=======================================\n"
    end

    ##########################################################
  end

  ##########################################################
  # widget class tree κ
  ##########################################################
  def gen_widget_class_tree(verbose = false)
    @verbose = verbose

    tree = Hash.new
    tree['.'] = [] ;# åȥ饹ޥɤ¸ߤʤΥ顼

    # ֥饹Ͽ
    @widget_rel.each{|rel|
      sub_cmd = []

      while rel != []
	cmd, sup_rel = rel

	# ꥢ
	if cmd.kind_of?(Array)
	  aliases = cmd.dup
	  cmd = aliases.shift
	  aliases.each{|c|
	    raise RuntimeError, "mismatch #{c}"  if tree[c] != nil
	    tree[c] = cmd
	  }
	end

	# Ͽ
	tree[cmd] = [] if tree[cmd] == nil
	tree[cmd] << sub_cmd unless sub_cmd == []

	# 
	sub_cmd = cmd
	rel = sup_rel
      end

      tree['.'] = [] if tree['.'] == nil
      tree['.'] << sub_cmd unless sub_cmd == []
    }

    # ֥饹ΥȤȽʣǤκ
    tree.each{|cmd, subs|
      next unless subs.kind_of?(Array)
      tree[cmd] = (subs | []).sort
    }

    # tree ֤
    tree
  end

  ##########################################################
  # widget class tree ɽ
  ##########################################################
  def disp_widget_class_tree(tree)
    disp_widget_class_tree_sub(tree, '.', 0)
  end

  ##########################################################
  # ᥽åɤ
  ##########################################################
  attr :base_namespace , true
  attr :base_cmd_list  , true
  attr :libname
  attr :namespace
  attr :cmd_list
  attr :new_cmd_list
  attr :ext_lib_info

  def ext_cmd_info
    @new_cmd_args
  end

end
##########################################################
# end of class TclTkExt_CmdChk
##########################################################

#############################
# ᥽åɽѥ饹
#############################
class GenTkExtDef
  INDENT = ' '*2

  ##########################################################
  # ¿Υ᥽åɤ private
  private

  # ᥽å
  def prn (line)
    if line == "\n"
      @fid.print line
    else
      @fid.print INDENT*@depth,line.sub(/^\t+/){ INDENT * ($&.size) }
    end
  end

  ###########################################################################

  # ͽΰ
  RESERVED_NAME = [
    'BEGIN',    'class',    'ensure',   'nil',      'self',     'when',
    'END',      'def',      'false',    'not',      'super',    'while',
    'alias',    'defined',  'for',      'or',       'then',     'yield',
    'and',      'do',       'if',       'redo',     'true',
    'begin',    'else',     'in',       'rescue',   'undef',
    'break',    'elsif',    'module',   'retry',    'unless',
    'case',     'end',      'next',     'return',   'until',
    ''  ]

  # ᥽åɤΰ¤Ӥ (ץʤ̥ޥ)
  def _args_gencmd_no_opt (all_args)
    # ǤƤʤ
    return ['*args'] unless all_args

    # ̾νʣ򤹤
    arg_names = []
    all_args.each{|arg|
      if arg.kind_of?(Array)
	arg.each{|a,v|
	  if a =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' 
	    arg_names << "args"
	  elsif a =~ /(\.\s*)(\.\s*)+\s*$/ # '...' ǽ
	    arg_names << "args"
	  elsif a == 'args'
	    arg_names << "args"
	  else
	    arg_names << a
	  end
	}
      elsif arg == 'args'
	arg_names << arg
      elsif arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' 
	arg_names << "args"
      elsif arg =~ /(\.\s*)(\.\s*)+\s*$/ # '...' ǽ
	arg_names << "args"
      elsif arg =~ /^\{.*\}$/  # { } Ƕޤ줿
	arg_names << "block"
      elsif arg[0] == ?- # '-' ǻϤޤ  switch
	arg_names << arg[1..-1]
      else
	# ƬϾʸˤ
	arg[0] = (arg[0,1] || '').tr("A-Z","a-z")
	arg_names << arg
      end
    }
    arg_names.collect!{|a| (RESERVED_NAME.include?(a))? 'arg_'+a: a }
    size = arg_names.size
    0.upto(size-1) {|i|
      cnt = 1
      (i+1).upto(size-1) {|j|
	if arg_names[i] == arg_names[j]
	  cnt += 1
	  arg_names[j] = arg_names[j] + cnt.to_s
	end
      }
      if cnt != 1
	arg_names[i] = arg_names[i] + '1'
      end
    }

    # ư
    flag = false
    arg_list = []
    all_args.each{|arg|
      if arg.kind_of?(Array)
	# άǽ
	flag = true
	arg.each{|a,v|
	  if a =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' 
	    # Ĥꤹ٤
	    arg_list << "*#{arg_names.shift}"
	    break
	  elsif a =~ /(\.\s*)(\.\s*)+\s*$/ # '...' ǽ
	    # Ĥꤹ٤
	    arg_list << "*#{arg_names.shift}"
	    break
	  elsif v == nil
	    if a[0] == ?- ;#  switch
	      arg_list << "#{arg_names.shift} = #{a}"
	    else
	      #arg_list << "#{a} = nil"
	      arg_list << "#{arg_names.shift} = nil"
	    end
	  elsif v == ''
	    #arg_list << "#{a} = '{}'"
	    arg_list << "#{arg_names.shift} = ''"
	  else
	    #arg_list << "#{a} = '#{v}'"
	    arg_list << "#{arg_names.shift} = '#{v}'"
	  end
	}

      elsif arg == 'args'
	# Ĥꤹ٤
	#arg_list << "*args"
	arg_list << "*#{arg_names.shift}"

      elsif arg =~ /^\s*(\.\s*)+\s*$/ # ñʤ '...' 
	if arg_list[-1] =~ /^\*/
	  # Ǥ˻Ĥꤹ٤Ƥ  ι̵
	  arg_names.shift
	else
	  #arg_list << "*args"
	  arg_list << "*#{arg_names.shift}"
	end

      elsif arg =~ /(\.\s*)(\.\s*)+\s*$/ # '...' ǽ
	if arg_list[-1] =~ /^\*/
	  # Ǥ˻Ĥꤹ٤Ƥ  ι̵
	  arg_names.shift
	else
	  #arg_list << "*args"
	  arg_list << "*#{arg_names.shift}"
	end

      elsif arg =~ /^\{.*\}$/  # { } Ƕޤ줿
	if flag
	  #arg_list << "block = ''"
	  arg_list << "#{arg_names.shift} = ''"
	else
	  #arg_list << "block"
	  arg_list << "#{arg_names.shift}"
	end

      else
	# άǽ
	if flag
	  #arg_list << "#{arg} = ''"
	  #arg_list << "#{arg_names.shift} = ''"
	  arg_list << "#{arg_names.shift} = nil"
	else
	  #arg_list << arg
	  arg_list << "#{arg_names.shift}"
	end
      end
    }

    # ۤ¤Ӥ֤
    arg_list
  end

  ###########################################################################

  # ̥ޥѥ᥽åɤ̾Τ
  def _decide_general_cmd_name(cmd)
    # namespace դʤ顤namespace ƬʸˤƷҤ
    # ľ namespace κǺʬʤȿˤʤΤǲäʤ
    cmd_base = ""
    cmd.split('::').reverse_each {|sp|
      next if cmd_base != "" && cmd_base =~ /^#{sp}/i
      # cmd_base = sp.capitalize + cmd_base
      cmd_base = (sp[0,1] || '').tr("a-z","A-Z") \
                 + (sp[1..-1] || '') + cmd_base

    }

    # ޥ̾ΰ '-' ޤʤ顤'_' ѹ
    cmd_base.tr!('-','_')

    # ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
    cmd_base.sub!(/\&/,'_and_')

    # Ƭĥ饤֥̾ˤʤäƤʤ顤ĹˤʤΤǺ
    cmd_base.sub!(/^#{@modname}/i,'')
    return '' if cmd_base == ''

    # ޥ̾ƬʸϾʸˤ
    # cmd_name = cmd_base.sub(/^./){|c| c.tr("A-Z","a-z")}
    cmd_name = cmd_base.dup
    cmd_name[0] = (cmd_base[0,1] || '').tr("A-Z","a-z")
    cmd_name
  end

  # 륦åȥȥ륳ޥѥ᥽åɤ̾Τ
  def _decide_widget_control_cmd_name(cmd)
    # ̥ޥѥ᥽åɤ̾ƱǤ褤
    _decide_general_cmd_name(cmd)
  end

  # 륦åȥ饹ޥѥ᥽åɤ̾Τ
  def _decide_widget_class_cmd_name(cmd)
    # ̥ޥѥ᥽åɤ̾ƱǤ褤
    _decide_general_cmd_name(cmd)
  end

  ###########################################################################

  # ʤޥɤФ᥽åɽ
  def general_cmd_without_arg (cmd_info)
    # ޥ̾η
    cmd_name = _decide_general_cmd_name(cmd_info[0])

    # ޥ̾ʤ顤Υޥ̾ƬʸˤơΤޤѤ
    if cmd_name == ''
      cmd_name = (cmd_info[0][0,1] || '').tr("A-Z","a-z") \
                 + (cmd_info[0][1..-1] || '')
    end

    # ޥ̾ΰ '-' ޤʤ顤'_' ѹ
    cmd_name.tr!('-','_')

    # ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
    cmd_name.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{cmd_name} ()
	Tk.tk_call( '#{cmd_info[0]}' )
end

END_OF_METHOD_FORM
  end

  # ץʤΥޥɤФ᥽åɽ
  def general_cmd_without_opt (cmd_info)
    # ޥ̾η
    cmd_name = _decide_general_cmd_name(cmd_info[0])

    # ޥ̾ʤ顤Υޥ̾ƬʸˤơΤޤѤ
    if cmd_name == ''
      cmd_name = (cmd_info[0][0,1] || '').tr("A-Z","a-z") \
                 + (cmd_info[0][1..-1] || '')
    end

    # ޥ̾ΰ '-' ޤʤ顤'_' ѹ
    cmd_name.tr!('-','_')

    # ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
    cmd_name.sub!(/\&/,'_and_')

    # ꥹȤγ (ǥե;ޤ)
    arg_list = _args_gencmd_no_opt(cmd_info[2])

    # ̾Τߤγ
    arg_names = arg_list.collect{|a| a.split(/\s+/)[0]}

    # ᥽å
=begin
Tk.tk_call  compact! 򤷤ƤΤǡǤ
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{cmd_name} (#{arg_list.join(', ')})
	args = [ #{arg_names.join(',')} ].compact
	Tk.tk_call( '#{cmd_info[0]}', *args )
end
=end
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{cmd_name} (#{arg_list.join(', ')})
	Tk.tk_call( '#{cmd_info[0]}', #{arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  # ᥽åɤΰ¤Ӥ (ץ󤢤ΰ̥ޥ)
  def _args_gencmd_with_opt (all_args, opt_pos)
    args = all_args.dup
    args[opt_pos - 1,1] = []
    _args_gencmd_no_opt(args)
  end

  # ץİ̥ޥɤǡ
  # ʸ륪ץФ᥽åɽ
  def general_cmd_with_string_opt(cmd, opt_pos, opt_name, arg_list, head = '')
    # ̾Τߤγ
    arg_names = arg_list.collect{|a| a.split(/\s+/)[0]}

    # ץ̾ɲ
    arg_names[opt_pos - 1, 0] = "'#{opt_name}'"

    # ץ̾ΰ '-' ޤʤ顤'_' ѹ
    opt_cmd = opt_name.tr('-','_')

    # ץ̾ΰ '&' ޤʤ顤'_and_' ѹ
    opt_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{head}#{opt_cmd.downcase} (#{arg_list.join(', ')})
	Tk.tk_call( '#{cmd}', #{arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  # ץİ̥ޥɤǡ
  # ͤʤɤεʸǤϤʤץФ᥽åɽ
  def general_cmd_with_type_opt(cmd, opt_pos, type_name, arg_list, head = '')
    # ̾Τߤγ
    arg_names = arg_list.collect{|a| a.split(/\s+/)[0]}

    # ɲåѥ᡼ѿ̾η
    param = 'param'
    param = 'param0' if arg_names.include?(param)
    param = 'prm00' if arg_names.include?(param)
    param.next while arg_names.include?(param)

    # ɲåѥ᡼ѿ̾ɲ
    arg_list[opt_pos - 1, 0] = "#{param}"
    arg_names[opt_pos - 1, 0] = "#{param}"

    # ̾ΰ '-' ޤʤ顤'_' ѹ
    type_cmd = type_name.tr('-','_')

    # ̾ΰ '&' ޤʤ顤'_and_' ѹ
    type_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{head}#{type_cmd.downcase} (#{arg_list.join(', ')})
	Tk.tk_call( '#{cmd}', #{arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  # ץİ̥ޥ
  def general_cmd_option (cmd, arg_list, opt_info, head = '')
    opt_pos = opt_info[0]

    # ʸǤϤʤץ(ͤʤ)
    types = ( opt_info[2].collect{|type, name|
      if type != 'type'
	nil
      else
	name.split(/\s+/)[-1]
      end
    }.compact ) | []

    # ʸǤϤʤץ(ͤʤ)Ф᥽åɽ
    if types.size == 1
      general_cmd_with_type_opt(cmd, opt_pos, 'call', arg_list, head)
    else
      types.each{|name|
	general_cmd_with_type_opt(cmd, opt_pos, 'call_'+name, arg_list, head)
      }
    end

    # ʸ󥪥ץФ᥽åɽ
    opt_info[2].each{|type, name|
      if type == 'string'
	general_cmd_with_string_opt(cmd, opt_pos, name, arg_list, head)
      elsif type == 'type'
	next ;# 
      else
	raise RuntimeError, "Unknown option type '#{type}'"
      end
    }
  end

  # ᥽åɤΰ¤Ӥ ( switch İ̥ޥ)
  def _args_gencmd_with_switch (all_args, switch_pos)
    args = all_args.dup
    args[switch_pos - 1,1] = []
    _args_gencmd_no_opt(args)
  end

  # switch Ĥ褦ʥץ󤢤ΰ̥ޥɤǡ
  # ʸ륪ץФ᥽åɽ
  def gencmd_with_string_opt_and_switch (cmd, opt_pos, opt_name, \
                                         arg_list, switch_info, head = '')
    # ץ̾ΰ '-' ޤʤ顤'_' ѹ
    opt_cmd = opt_name.tr('-','_')

    # ץ̾ΰ '&' ޤʤ顤'_and_' ѹ
    opt_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{head}#{opt_cmd.downcase} ( *args )
	eofsw = 0
	args.each_with_index{|sw,eofsw| break if sw[0] != ?- || sw == '--'}
	args[eofsw+#{opt_pos},0] = "'#{opt_name}'"
	Tk.tk_call( '#{cmd}', *args )
end

END_OF_METHOD_FORM
  end

  # switch Ĥ褦ʥץ󤢤ΰ̥ޥɤǡ
  # ͤʤɤεʸǤϤʤץФ᥽åɽ
  def gencmd_with_type_opt_and_switch (cmd, opt_pos, type_name, \
                                       arg_list, switch_info, head = '')
    # ̾ΰ '-' ޤʤ顤'_' ѹ
    type_cmd = type_name.tr('-','_')

    # ̾ΰ '&' ޤʤ顤'_and_' ѹ
    type_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{head}#{type_cmd.downcase} ( *args )
	Tk.tk_call( '#{cmd}', #{arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  # ץ switch Ȥİ̥ޥ
  def general_cmd_opt_and_switch (cmd, arg_list, opt_info, \
                                  switch_info, head = '')
    # switch 򽸤ơץꤷƸƤӽФ褦ʥ᥽åɤȤ
    opt_pos = opt_info[0]

    # ʸǤϤʤץ(ͤʤ)
    types = ( opt_info[2].collect{|type, name|
      if type != 'type'
	nil
      else
	name.split(/\s+/)[-1]
      end
    }.compact ) | []

    # ʸǤϤʤץ(ͤʤ)Ф᥽åɽ
    if types.size == 1
      gencmd_with_type_opt_and_switch(cmd, opt_pos, 'call', \
					arg_list, switch_info, head)
    else
      types.each{|name|
	gencmd_with_type_opt_and_switch(cmd, opt_pos, 'call_'+name, \
					arg_list, switch_info, head)
      }
    end

    # ʸ󥪥ץФ᥽åɽ
    opt_info[2].each{|type, name|
      if type == 'string'
	gencmd_with_string_opt_and_switch(cmd, opt_pos, name, \
					  arg_list, switch_info, head)
      elsif type == 'type'
	next ;# 
      else
	raise RuntimeError, "Unknown option type '#{type}'"
      end
    }
  end

  # switch Τߤİ̥ޥ
  def general_cmd_switch (cmd, arg_list, switch_info)
    # switch ˤĹˤʤΤǡ򤽤ΤޤްϤ᥽åɤȤ

    # ޥ̾η
    cmd_name = _decide_general_cmd_name(cmd)

    # ޥ̾ΰ '-' ޤʤ顤'_' ѹ
    cmd_name.tr!('-','_')

    # ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
    cmd_name.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{cmd_name} ( *args )
	Tk.tk_call( '#{cmd}', *args )
end

END_OF_METHOD_FORM
  end

  # ץİ̥ޥ
  def general_cmd_with_opt (cmd_info)
    # ޥɥ⥸塼̾
    # ̥ޥ̾
    # Ƭʸʸˤ塤Ƭ˥⥸塼̾ɲä
    cmdmod_name = _decide_general_cmd_name(cmd_info[0])
    # cmdmod_name = @modname + cmdmod_name.capitalize
    cmdmod_name = (cmdmod_name[0,1] || '').tr("a-z","A-Z") \
                  + (cmdmod_name[1..-1] || '')
    cmdmod_name = @modname + cmdmod_name

    # options
    opt_info = cmd_info[4]
    case opt_info[1]
    when 'option'
      arg_list = _args_gencmd_with_opt(cmd_info[2], opt_info[0])

      # cmdmod_name  @modname ƱˤʤäƤޤäƤ뤫
      if cmdmod_name =~ /^#{@modname}$/i
	# Ʊ  ޥ̾פ
	general_cmd_option (cmd_info[0], arg_list, opt_info, 
			    @modname.downcase + '_')
      else
	# ۤʤ  ޥɤб⥸塼
	prn "module #{cmdmod_name}\n"
	@depth += 1
	general_cmd_option (cmd_info[0], arg_list, opt_info)
	@depth -= 1
	prn "end ; # end of module #{cmdmod_name}\n\n"
      end

    when 'switch'
      switch_info = opt_info
      if cmd_info.size > 5
	opt_info = cmd_info[5]
	arg_list = _args_gencmd_with_switch(cmd_info[2], opt_info[0])

	# cmdmod_name  @modname ƱˤʤäƤޤäƤ뤫
	if cmdmod_name =~ /^#{@modname}$/i
	  # Ʊ  ޥ̾פ
	  general_cmd_opt_and_switch(cmd_info[0],arg_list,opt_info,switch_info,
				     @modname.downcase + '_')
	else
	  # ۤʤ  ޥɤб⥸塼
	  prn "module #{cmdmod_name}\n"
	  @depth += 1
	  general_cmd_opt_and_switch(cmd_info[0],arg_list,opt_info,switch_info)
	  @depth -= 1
	  prn "end ; # end of module #{cmdmod_name}\n\n"
	end

      else
	general_cmd_switch(cmd_info[0], arg_list, switch_info)

      end

    else
      raise RuntimeError, "Unknown opt_type '#{opt_info[1]}'"

    end

  end

  # ̥ޥɤ˴ؤ᥽åɽ
  def general_cmd (cmd_info)
    if (cmd_info[2] == [])
      # ʤ
      general_cmd_without_arg (cmd_info)
    elsif (cmd_info[4] == [] || cmd_info[4] == nil)
      # ץʤ
      general_cmd_without_opt (cmd_info)
    else
      # ץ󤢤
      general_cmd_with_opt (cmd_info)
    end
  end

  ###########################################################################

  # ᥽åɤΰ¤Ӥ
  # (ץ󤢤ꥦåȥȥ륳ޥ)
  def _args_w_control_with_opt (all_args, opt_pos)
    args = all_args.dup
    args[opt_pos - 1,1] = []
    _args_gencmd_no_opt(args)
  end

  # ץĥåȥȥ륳ޥɤǡ
  # ʸ륪ץФ᥽åɽ
  def widget_control_with_string_opt(mod, cmd, w_arg_pos, \
                                     opt_pos, opt_name, arg_list)
    # ̾Τߤγ
    arg_names = arg_list.collect{|a| a.split(/\s+/)[0]}

    # ץ̾ɲ
    arg_names[opt_pos - 1, 0] = "'#{opt_name}'"

    # åȰ
    arg_names[w_arg_pos - 1] = arg_names[w_arg_pos - 1] + '.path'

    # 󥹥󥹥᥽åѰγ
    inst_arg_list = arg_list.dup
    inst_arg_list.delete_at(w_arg_pos - 1)
    inst_arg_names = arg_names.dup
    inst_arg_names[w_arg_pos - 1] = 'self'
    inst_arg_names.delete_at(opt_pos - 1)

    # ץ̾ΰ '-' ޤʤ顤'_' ѹ
    opt_cmd = opt_name.tr('-','_')

    # ץ̾ΰ '&' ޤʤ顤'_and_' ѹ
    opt_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{mod}.#{opt_cmd.downcase} (#{arg_list.join(', ')})
	Tk.tk_call( '#{cmd}', #{arg_names.join(', ')} )
end
def #{opt_cmd.downcase} (#{inst_arg_list.join(', ')})
	#{mod}.#{opt_cmd.downcase} ( #{inst_arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  # ץĥåȥȥ륳ޥ
  def widget_control_option (mod, cmd, w_arg_pos, arg_list, opt_info)
    opt_pos = opt_info[0]

    # ʸǤϤʤץ(ͤʤ)
    types = ( opt_info[2].collect{|type, name|
      if type != 'type'
	nil
      else
	name.split(/\s+/)[-1]
      end
    }.compact ) | []

    # ʸǤϤʤץ(ͤʤ)Ф᥽åɽ
    if types.size == 1
      widget_control_with_type_opt(mod, cmd, w_arg_pos, opt_pos, 
				   'call', arg_list)
    else
      types.each{|name|
	widget_control_with_type_opt(mod, cmd, w_arg_pos, opt_pos, 
				     'call_'+name, arg_list)
      }
    end

    # ʸ󥪥ץФ᥽åɽ
    opt_info[2].each{|type, name|
      if type == 'string'
	widget_control_with_string_opt(mod, cmd, w_arg_pos, opt_pos, 
				       name, arg_list)
      elsif type == 'type'
	next ;# 
      else
	raise RuntimeError, "Unknown option type '#{type}'"
      end
    }
  end

  # ᥽åɤΰ¤Ӥ 
  # ( switch ĥåȥȥ륳ޥ)
  def _args_w_control_with_switch (all_args, switch_pos)
    args = all_args.dup
    args[switch_pos - 1,1] = []
    _args_gencmd_no_opt(args)
  end

  # switch Ĥ褦ʥץ󤢤Υåȥȥ륳ޥɤǡ
  # ʸ륪ץФ᥽åɽ
  def widget_control_with_string_opt_and_switch (mod, cmd, w_arg_pos, \
                                                 opt_pos, opt_name, \
                                                 arg_list, switch_info)
    # ץ̾ΰ '-' ޤʤ顤'_' ѹ
    opt_cmd = opt_name.tr('-','_')

    # ץ̾ΰ '&' ޤʤ顤'_and_' ѹ
    opt_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{mod}.#{opt_cmd.downcase} ( *args_src )
	args = args_src.dup
	eofsw = 0
	args.each_with_index{|sw,eofsw| break if sw[0] != ?- || sw == '--'}
	args[eofsw+#{opt_pos},0] = "'#{opt_name}'"
	args[eofsw+#{w_arg_pos}] = args[eofsw+#{w_arg_pos}].path
	Tk.tk_call( '#{cmd}', *args )
end
def #{opt_cmd.downcase} ( *args_src )
	args = args_src.dup
	eofsw = 0
	args.each_with_index{|sw,eofsw| break if sw[0] != ?- || sw == '--'}
	args[eofsw+#{opt_pos},0] = "'#{opt_name}'"
	args[eofsw+#{w_arg_pos}] = self
	args.delete_at(eofsw+#{opt_pos})
	Tk.tk_call( '#{cmd}', *args )
end

END_OF_METHOD_FORM
  end

  # switch Ĥ褦ʥץ󤢤Υåȥȥ륳ޥɤǡ
  # ͤʤɤεʸǤϤʤץФ᥽åɽ
  def widget_control_with_type_opt_and_switch (mod, cmd, w_arg_pos, \
                                               opt_pos, type_name, \
                                               arg_list, switch_info)
    # ̾ΰ '-' ޤʤ顤'_' ѹ
    type_cmd = type_name.tr('-','_')

    # ̾ΰ '&' ޤʤ顤'_and_' ѹ
    type_cmd.sub!(/\&/,'_and_')

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{mod}.#{type_cmd.downcase} ( *args_src )
	args = args_src.dup
	eofsw = 0
	args.each_with_index{|sw,eofsw| break if sw[0] != ?- || sw == '--'}
	args[eofsw+#{w_arg_pos}] = args[eofsw+#{w_arg_pos}].path
	Tk.tk_call( '#{cmd}', *args )
end
def #{type_cmd.downcase} ( *args_src )
	args = args_src.dup
	eofsw = 0
	args.each_with_index{|sw,eofsw| break if sw[0] != ?- || sw == '--'}
	args[eofsw+#{w_arg_pos}] = self
	#{mod}.#{type_cmd.downcase} ( *args )
end

END_OF_METHOD_FORM
  end

  # ץ switch Ȥĥåȥȥ륳ޥ
  def widget_control_opt_and_switch (mod, cmd, w_arg_pos, \
                                     arg_list, opt_info, switch_info)
    # switch 򽸤ơץꤷƸƤӽФ褦ʥ᥽åɤȤ
    opt_pos = opt_info[0]

    # ʸǤϤʤץ(ͤʤ)
    types = ( opt_info[2].collect{|type, name|
      if type != 'type'
	nil
      else
	name.split(/\s+/)[-1]
      end
    }.compact ) | []

    # ʸǤϤʤץ(ͤʤ)Ф᥽åɽ
    if types.size == 1
      widget_control_with_type_opt_and_switch(mod, cmd, w_arg_pos, opt_pos, 
					      'call', arg_list, switch_info)
    else
      types.each{|name|
	widget_control_with_type_opt_and_switch(mod, cmd, w_arg_pos, opt_pos, 
                                                'call_'+name, arg_list, 
                                                switch_info)
      }
    end

    # ʸ󥪥ץФ᥽åɽ
    opt_info[2].each{|type, name|
      if type == 'string'
	widget_control_with_string_opt_and_switch(mod, cmd, w_arg_pos, 
                                                  opt_pos, name, 
					          arg_list, switch_info)
      elsif type == 'type'
	next ;# 
      else
	raise RuntimeError, "Unknown option type '#{type}'"
      end
    }
  end

  # ץ󤢤Υåȥȥ륳ޥɤФ᥽åɽ
  def widget_control_cmd_with_opt (cmd_info)
    # ޥɥ⥸塼̾
    # åȥȥ륳ޥ̾
    # Ƭʸʸˤ塤Ƭ˥⥸塼̾ɲä
    cmdmod_name = _decide_widget_control_cmd_name(cmd_info[0])
    # cmdmod_name = @modname + cmdmod_name.capitalize
    cmdmod_name = (cmdmod_name[0,1] || '').tr("a-z","A-Z") \
                  + (cmdmod_name[1..-1] || '')
    cmdmod_name = @modname + cmdmod_name

    # cmdmod_name  @modname ƱˤʤäƤޤäƤ뤫
    if cmdmod_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      cmdmod_name = @modname + '_'
    end

    # åȰΰ֤
    w_arg_pos = $1.to_i if cmd_info[3] =~ /^widget-control:(\d+)$/

    # ⥸塼Ƭ
    prn "module #{cmdmod_name}\n"
    @depth += 1

    # options
    opt_info = cmd_info[4]
    case opt_info[1]
    when 'option'
      arg_list = _args_w_control_with_opt(cmd_info[2], opt_info[0])
      widget_control_option (cmdmod_name, cmd_info[0], 
			     w_arg_pos, arg_list, opt_info)

    when 'switch'
      switch_info = opt_info
      opt_info = cmd_info[5]
      arg_list = _args_w_control_with_switch(cmd_info[2], opt_info[0])
      widget_control_opt_and_switch(cmdmod_name, cmd_info[0], w_arg_pos, 
				    arg_list, opt_info, switch_info)

    else
      raise RuntimeError, "Unknown opt_type '#{opt_info[1]}'"
    end

    # ⥸塼
    @depth -= 1
    prn "end ; # end of module #{cmdmod_name}\n\n"

  end

  # ץʤΥåȥȥ륳ޥɤФ᥽åɽ
  def widget_control_cmd_without_opt (cmd_info)
    # ޥ̾η
    cmd_name = _decide_widget_control_cmd_name(cmd_info[0])

    # ޥ̾ʤ顤Υޥ̾ƬʸˤơΤޤѤ
    if cmd_name == ''
      cmd_name = (cmd_info[0][0,1] || '').tr("A-Z","a-z") \
                 + (cmd_info[0][1..-1] || '')
    end

    # ޥ̾ΰ '-' ޤʤ顤'_' ѹ
    cmd_name.tr!('-','_')

    # ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
    cmd_name.sub!(/\&/,'_and_')

    # ꥹȤγ (ǥե;ޤ)
    arg_list = _args_gencmd_no_opt(cmd_info[2])

    # ̾Τߤγ
    arg_names = arg_list.collect{|a| a.split(/\s+/)[0]}

    # åȰΰ֤
    w_arg_pos = $1.to_i if cmd_info[3] =~ /^widget-control:(\d+)$/

    # åȰ
    arg_list.delete_at(w_arg_pos - 1)
    arg_names[w_arg_pos - 1] = 'path' ;# <= self.path

    # ᥽å
    ( <<END_OF_METHOD_FORM ).each_line{|l| prn l}
def #{cmd_name} (#{arg_list.join(', ')})
	tk_call( '#{cmd_info[0]}', #{arg_names.join(', ')} )
end

END_OF_METHOD_FORM
  end

  ###########################################################################

  # åȥ饹οƻҥڥꥹȤγ
  def get_parent_child_class_pair(parent)
    # ҥ饹ʤ nil ֤
    return nil if @widget_class_tree[parent] == []

    # ƻҥ饹ˤĤƤν
    sub_list = []
    @widget_class_tree[parent].each{|child|
      # alias ޥɽ
      aliases = @widget_class_tree.keys.find_all{|c| 
	@widget_class_tree[c].kind_of?(String) && @widget_class_tree[c]==child
      }

      # ƻҥڥɲ
      if aliases && aliases != []
	sub_list << ( [parent, child] + aliases )
      else
	sub_list << [parent, child]
      end

      # ҥ饹λҥ饹ˤĤƤν
      subsub_list = get_parent_child_class_pair(child)

      # ҥ饹λҥ饹ˤĤ nil Ǥʤɲ
      sub_list += subsub_list if subsub_list != nil
    }
      
    # 饹οƻҥڥΥꥹȤ֤
    sub_list
  end

  # åȥ饹ޥɤ˴ؤ᥽åɽ
  def widget_class_cmd (parent_info, child_info)
    # ƻҤ줾˥ޥɥ饹̾
    # åȥ饹ޥ̾
    # Ƭʸʸˤ塤Ƭ˥⥸塼̾ɲä
    if parent_info == nil
      parent_name = 'TkWindow'
    else
      parent_name = _decide_widget_class_cmd_name(parent_info[0])
      # parent_name = @modname + parent_name.capitalize
      parent_name = (parent_name[0,1] || '').tr("a-z","A-Z") \
                      + (parent_name[1..-1] || '')
      parent_name = @modname + parent_name
    end
    child_name = _decide_widget_class_cmd_name(child_info[0])
    # child_name = @modname + child_name.capitalize
    child_name = (child_name[0,1] || '').tr("a-z","A-Z") \
                 + (child_name[1..-1] || '')
    child_name = @modname + child_name

    # @modname ƱˤʤäƤޤäƤ뤫
    if parent_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      parent_name = @modname + '_'
    end
    if child_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      child_name = @modname + '_'
    end

    # ֥ޥɺʬ
    if parent_info == nil
      subcmd_diff = child_info[4][0]
    else
      subcmd_diff = (child_info[4][0] - parent_info[4][0]).sort
    end    

    # 饹Ƭ
    prn "class #{child_name}<#{parent_name}\n"
    @depth += 1

    # åѤΥ᥽å
    prn "def create_self\n"
    prn "	tk_call '#{child_info[0]}', @path\n"
    prn "end\n"

    # ֥ޥɤΤΥ᥽å
    if subcmd_diff != []
      prn "\n" 
      subcmd_diff.each{|cmd|
	# ޥ̾ΰ '-' ޤʤ顤'_' ѹ
	cmd_name = cmd.tr('-','_')

	# ޥ̾ΰ '&' ޤʤ顤'_and_' ѹ
	cmd_name.sub!(/\&/,'_and_')

	# ʤΤǡä򤽤ΤޤϤ褦
	prn "def #{cmd_name} (*args)\n"
	prn "	tk_send '#{cmd}', *args\n"
	prn "end\n"
	prn "\n"
      }
    end

    # 饹
    @depth -= 1
    prn "end ; # end of class #{child_name}\n\n"
  end

  # åȥ饹ޥɤ alias 
  def widget_class_alias (cmd, alias_cmd)
    # 줾˥ޥɥ饹̾
    # åȥ饹ޥ̾
    # Ƭʸʸˤ塤Ƭ˥⥸塼̾ɲä
    cmd_name = _decide_widget_class_cmd_name(cmd)
    # cmd_name = @modname + cmd_name.capitalize
    cmd_name = (cmd_name[0,1] || '').tr("a-z","A-Z") \
               + (cmd_name[1..-1] || '')
    cmd_name = @modname + cmd_name
    alias_name = _decide_widget_class_cmd_name(alias_cmd)
    # alias_name = @modname + alias_name.capitalize
    alias_name = (alias_name[0,1] || '').tr("a-z","A-Z") \
                 + (alias_name[1..-1] || '')
    alias_name = @modname + alias_name

    # @modname ƱˤʤäƤޤäƤ뤫
    if cmd_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      cmd_name = @modname + '_'
    end
    if alias_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      alias_name = @modname + '_'
    end

    # alias 
    prn "#{alias_name} = #{cmd_name}\n\n"
  end

  # ץ˼Ԥåȥ饹ޥɤ˴ؤ᥽åɽ
  def widget_class_cmd_opt_unknown (cmd_info)
    # ޥɥ饹̾
    # åȥ饹ޥ̾
    # Ƭʸʸˤ塤Ƭ˥⥸塼̾ɲä
    cmdclass_name = _decide_widget_class_cmd_name(cmd_info[0])
    # cmdclass_name = @modname + cmdclass_name.capitalize
    cmdclass_name = (cmdclass_name[0,1] || '').tr("a-z","A-Z") \
                      + (cmdclass_name[1..-1] || '')
    cmdclass_name = @modname + cmdclass_name

    # cmdclass_name  @modname ƱˤʤäƤޤäƤ뤫
    if cmdclass_name =~ /^#{@modname}$/i
      # Ʊ  ޥ̾פ
      cmdclass_name = @modname + '_'
    end

    # 饹Ƭ ( TkWindow λҥ饹Ȥ )
    prn "class #{cmdclass_name}<TkWindow\n"
    @depth += 1

    # ᥽å ( åȤǤʤ )
    prn "def create_self\n"
    prn "	tk_call '#{cmd_info[0]}', @path\n"
    prn "end\n"

    # 饹
    @depth -= 1
    prn "end ; # end of class #{cmdclass_name}\n\n"
  end

  ###########################################################################

  # ޥ¸ߥå
  def cmd_type_exist_check ()
    @general_with_opt = 0
    @general_without_opt = 0
    @w_cntl_with_opt = 0
    @w_cntl_without_opt = 0
    @widget_class_cmd = 0

    @all_cmd_info.each{|cmd_info|
      case cmd_info[3]
      when 'general-cmd'
	if (cmd_info[4] == [] || cmd_info[4] == nil)
	  @general_without_opt += 1
	elsif cmd_info[0] =~ /^#{@modname}$/i
	  @general_without_opt += 1
	elsif cmd_info[4][1] == 'switch' && cmd_info.size <= 5
	  @general_without_opt += 1
	else
	  @general_with_opt += 1
	end
      when /^widget-control:\d+$/
	if (cmd_info[4] == [] || cmd_info[4] == nil)
	  @w_cntl_without_opt += 1
	else
	  @w_cntl_with_opt += 1
	end
      when 'widget-class-cmd'
	@widget_class_cmd += 1
      end
    }

    @cmd_type_exist_check = true
  end

  # ĥ饤֥եν
  def gen_extlib_inf_file (extlib_info)
    fid = open(@inffile, "w")
    fid.print("EXTLIB_INFO = #{extlib_info.inspect}\n")
  end

  # ᥽å
  def initialize (module_name, extlib_info, all_cmd_info, widget_class_tree)
    # ⥸塼̾ƬʸˤʤäƤʤʸˤ
    # @modname = module_name.capitalize
    @modname = (module_name[0,1] || '').tr("a-z","A-Z") \
               + (module_name[1..-1] || '')

    @fid = open("#{module_name}.rb", "w")

    @inffile = "#{module_name}.inf"
    gen_extlib_inf_file(extlib_info)

    @all_cmd_info = all_cmd_info
    @widget_class_tree = widget_class_tree

    @depth = 0
    @cmd_type_exist_check = false

    # ϥեƬν
    prn "#\n"
    prn "# This file was generated by "\
	+ "'mk_tkextlib.rb ver.#{$Mk_TkExtLib_Version}'\n"
    prn "#       ( based on "\
	+ "'tcltkextlib.rb ver.#{$TclTkExtLib_Version}' )\n"
    prn "#\n"
    prn "\n"
    prn "require 'tkext'\n\n"
  end

  ###########################################################################
  # ʹ public
  public

  # ̥ޥɤ
  def generate_general_cmd_definition ()
    cmd_type_exist_check unless @cmd_type_exist_check

    # ץʤΰ̥ޥ
    # Ƭʬ
    prn "module #{@modname}\n"
    @depth += 1
    prn "extend #{@modname}\n"
    prn "\n"

    # ĥ饤֥Υ
    prn "# load Tck/Tk ext-package library\n"
    prn "load '#{@inffile}'\n"
    prn "EXTLIB_INFO.each{|lib| Tk.setup_libs(lib) if lib} if EXTLIB_INFO\n"
    prn "\n"

    # ƥޥɤν
    if @general_without_opt != 0
      @all_cmd_info.each{|cmd_info|
	next if cmd_info[3] != 'general-cmd'
	if (cmd_info[4] == [] || cmd_info[4] == nil)
	  general_cmd(cmd_info)
	elsif cmd_info[0] =~ /^#{@modname}$/i
	  # ޥ̾ȥ⥸塼̾СץŸϿ
	  general_cmd(cmd_info)
	elsif cmd_info[4][1] == 'switch' && cmd_info.size <= 5
	  # ץȤƤ switch ʤ
	  general_cmd(cmd_info)
	end
      }
    end

    # ʬ
    @depth -= 1
    prn "end ; # end of module #{@modname}\n\n"

    # ץ󤢤ΰ̥ޥ
    return if @general_with_opt == 0

    # ƥޥɤν
    @all_cmd_info.each{|cmd_info|
      next if cmd_info[3] != 'general-cmd'
      next if (cmd_info[4] == [] || cmd_info[4] == nil)
      next if cmd_info[0] =~ /^#{@modname}$/i
      next if cmd_info[4][1] == 'switch' && cmd_info.size <= 5
      general_cmd(cmd_info)
    }

  end

  # åȥȥ륳ޥɤ
  def generate_widget_control_cmd_definition ()
    cmd_type_exist_check unless @cmd_type_exist_check

    # ץ󤢤Υåȥȥ륳ޥ
    if @w_cntl_with_opt != 0
      @all_cmd_info.each{|cmd_info|
	next if cmd_info[3] !~ /^widget-control:\d+$/
	next if (cmd_info[4] == [] || cmd_info[4] == nil)
	next if (cmd_info[4][1] != 'option' && cmd_info.size <= 5)
	widget_control_cmd_with_opt (cmd_info)
      }
    end

    # ץʤΥåȥȥ륳ޥ
    if @w_cntl_without_opt != 0
      # Ƭʬ ( TkWindow Υ᥽åɤȤɲä )
      prn "class TkWindow\n"
      @depth += 1

      @all_cmd_info.each{|cmd_info|
	next if cmd_info[3] !~ /^widget-control:\d+$/
	next unless (cmd_info[4] == [] || cmd_info[4] == nil)
	next unless (cmd_info[4][1] != 'option' && cmd_info.size <= 5)
	widget_control_cmd_without_opt (cmd_info)
      }

      # ʬ
      @depth -= 1
      prn "end; # end of new methods of 'TkWindow' class\n\n"
    end
  end

  # åȥ饹ޥɤ
  def generate_widget_class_cmd_definition ()
    cmd_type_exist_check unless @cmd_type_exist_check
    return if @widget_class_cmd == 0

    # ץ줿ޥɤν
    class_pair = get_parent_child_class_pair('.')
    class_pair.each{|parent, child, *aliases|
      if (parent == '.')
	parent_info = nil
      else
	parent_info = @all_cmd_info.find{|cmd_info| cmd_info[0] == parent}
      end
      child_info = @all_cmd_info.find{|cmd_info| cmd_info[0] == child}
      widget_class_cmd(parent_info, child_info)
      if aliases && aliases != []
	aliases.each{|alias_cmd| widget_class_alias(child_info[0], alias_cmd)}
      end
    }

    # ץʤäޥɤν
    @all_cmd_info.each{|cmd_info|
      next if cmd_info[3] != 'widget-class-cmd'
      next unless cmd_info[4] == nil
      widget_class_cmd_opt_unknown (cmd_info)
    }

  end

end
##########################################################
# end of class GenTkExtDef
##########################################################



##########################################################
# main
##########################################################
#verbose = 'DEBUG'
#verbose = true
verbose = false
cmd_args = $*.dup

$pre_load_lib = [ nil ] ;# ǥեȤǤϸ׵᤹饤֥Ϥʤ

def disp_usage ()
  STDERR.print "Usage: mk_tkextlib.rb [-v] [-b base_info [-g]] [-p pkg_name]\n"
end

##########################################################
# ޥɥ饤󥪥ץĴ
opt_cnt = getopts('gv','b:','p:')
if opt_cnt == nil || opt_cnt == 0
  disp_usage
  exit
end
if $OPT_b == nil && $OPT_p == nil
  disp_usage
  exit
end

##########################################################
# verbose ץ
verbose = true if $OPT_v

##########################################################
print "# ¹Իޥɥ饤\n",$0,' ',cmd_args.join(' '),"\n\n" if verbose

##########################################################
# ĥѥå load
if $OPT_p
  STDERR.print "ĥѥåե̾ = #{$OPT_p}\n" if verbose
  STDERR.print "ĥѥå .#{File::Separator}#{$OPT_p}.def  load\n" if verbose
  load '.' + File::Separator + $OPT_p + '.def'
end

##########################################################
print "\n# \n" if verbose
if $OPT_g == nil && $OPT_b != nil
  # ֤ɤ߹
  cmdchk = TclTkExt_CmdChk.new(nil, verbose)
else
  # ֤ϸΥ󥿡ץ꥿ǳ
  cmdchk = TclTkExt_CmdChk.new($pre_load_lib, verbose)
end

##########################################################
# base_info ɤ߹ or 
if $OPT_g == nil && $OPT_b != nil
  # base_info ɤ߹
  print "\n# base_info ե '#{$OPT_b}' ɤ߹\n" if verbose
  begin
    load $OPT_b
  rescue
    disp_usage
    raise
  end

  cmdchk.base_namespace = $base_namespace
  cmdchk.base_cmd_list  = $base_cmd_list

elsif $OPT_g == true
  # base_info 
  if $OPT_b == nil
    disp_usage
    exit
  end

  print "\n# base_info ե '#{$OPT_b}' \n" if verbose
  begin
    f = open($OPT_b, "w")
    f.print "$base_namespace = #{cmdchk.base_namespace.inspect}\n"
    f.print "\n"
    f.print "$base_cmd_list  = #{cmdchk.base_cmd_list.inspect}\n"
  rescue
    disp_usage
    raise
  ensure
    f.close
  end
end

##########################################################
# ĥѥå꤬ʤнλ
unless $OPT_p
  print "\n# λ\n" if verbose
  exit
end

##########################################################
print "\n# ĥѥåƳ\n" if verbose
libname = cmdchk.load_ext_library($ext_lib_info, verbose)

##########################################################
print "\n# ĥѥåˤɲåޥɤθ\n" if verbose
print "#############################################\n"
print " () ʲȯ Tcl/Tk Υ顼\n"
print "      ԹΤǤΤǡ\n"
print "      ̵̾뤷Ƥޤʤ\n"
print "#############################################\n"
cmdchk.check_new_command(verbose)
print "#############################################\n\n"

##########################################################
print "\n# 饹إǡ¤ν\n" if verbose
widget_class_tree = cmdchk.gen_widget_class_tree(verbose)
p widget_class_tree if verbose == 'DEBUG'
print "=======================================\n"
print "Widget Class Tree of Package '#{cmdchk.libname}'\n"
print "---------------------------------------\n"
cmdchk.disp_widget_class_tree(widget_class_tree)
print "=======================================\n"

##########################################################

##########################################################
print "\n# 饹/⥸塼ե\n" if verbose
extdef = GenTkExtDef.new(cmdchk.libname, cmdchk.ext_lib_info, 
			 cmdchk.ext_cmd_info, widget_class_tree)

print "\n# ̥ޥ\n" if verbose
extdef.generate_general_cmd_definition

print "\n# åȥȥ륳ޥ\n" if verbose
extdef.generate_widget_control_cmd_definition

print "\n# åȥ饹ޥ\n" if verbose
extdef.generate_widget_class_cmd_definition

print "\n# ϴλ\n" if verbose
